part of tecfy_corev2_client_package;

class LocalConfigService {
  static bool get isArabic => (language == Language.arabic);

  static String get languagePrefix =>
      (language == Language.arabic) ? 'Ar' : 'En';

  static Language get language {
    var value = ConfigService.getValueInt(ConfigKeys.language);
    var lang = value == 0 ? Language.arabic : Language.values[value];
    return lang;
  }

  static bool get expertMode {
    if (!ConfigService.checkValueExist('ExpertMode')) {
      if (kIsWeb) {
        ConfigService.setValueBool('ExpertMode', true);
        return true;
      }
      return false;
    }
    return ConfigService.getValueBool('ExpertMode');
  }

  static User? get user =>
      User.fromJson(ConfigService.getValueMap(ConfigKeys.user));
  static Map<String, dynamic> get company =>
      ConfigService.getValueMap(ConfigKeys.company);
  static set company(v) => ConfigService.setValueMap(ConfigKeys.company, v);

  static Future<bool> saveUser(User u) =>
      ConfigService.setValueMap(ConfigKeys.user, u.toJson());

  static set language(Language v) {
    ConfigService.setValueInt(ConfigKeys.language, v.index).then((d) {
      ConfigService.isRTL = (v == Language.arabic);
      AppLocale.languageStreamController.add(LocalConfigService.language);
    });
  }

  static set operationMode(OperationMode v) {
    ConfigService.setValueInt(ConfigKeys.operation_mode, v.index);
  }

  static OperationMode get operationMode {
    if (TecfyBasicApp.isTest) return OperationMode.offline_cache_all;
    var value = ConfigService.getValueInt(ConfigKeys.operation_mode);
    var op = OperationMode.values[value];
    return op;
  }
}

enum ConfigKeys { user, language, company, operation_mode }

enum Language { notSelected, arabic, english }

enum OperationMode {
  online,
  offline_cache_required,
  offline_cache_3months,
  offline_cache_6months,
  offline_cache_12months,
  offline_cache_all
}
